//-----------------------------------------------------------------------------
// system_top.v
//-----------------------------------------------------------------------------

module system_top
  (
    zio,
    rzq,
    mcbx_dram_we_n,
    mcbx_dram_udqs_n,
    mcbx_dram_udqs,
    mcbx_dram_udm,
    mcbx_dram_ras_n,
    mcbx_dram_odt,
    mcbx_dram_ldm,
    mcbx_dram_dqs_n,
    mcbx_dram_dqs,
    mcbx_dram_dq,
    mcbx_dram_clk_n,
    mcbx_dram_clk,
    mcbx_dram_cke,
    mcbx_dram_cas_n,
    mcbx_dram_ba,
    mcbx_dram_addr,
    RS232_Uart_1_sout,
    RS232_Uart_1_sin,
    RESET,
    Push_Buttons_5Bits_TRI_I,
    LEDs_8Bits_TRI_O,
    GCLK,
    DIP_Switches_8Bits_TRI_I,
    Digilent_AC97_Cntlr_BITCLK_pin,
    Digilent_AC97_Cntlr_SDATA_IN_pin,
    Digilent_AC97_Cntlr_SDATA_OUT_pin,
    Digilent_AC97_Cntlr_SYNC_pin,
    Digilent_AC97_Cntlr_RESET_N_pin
  );
  inout zio;
  inout rzq;
  output mcbx_dram_we_n;
  inout mcbx_dram_udqs_n;
  inout mcbx_dram_udqs;
  output mcbx_dram_udm;
  output mcbx_dram_ras_n;
  output mcbx_dram_odt;
  output mcbx_dram_ldm;
  inout mcbx_dram_dqs_n;
  inout mcbx_dram_dqs;
  inout [15:0] mcbx_dram_dq;
  output mcbx_dram_clk_n;
  output mcbx_dram_clk;
  output mcbx_dram_cke;
  output mcbx_dram_cas_n;
  output [2:0] mcbx_dram_ba;
  output [12:0] mcbx_dram_addr;
  output RS232_Uart_1_sout;
  input RS232_Uart_1_sin;
  input RESET;
  input [0:4] Push_Buttons_5Bits_TRI_I;
  output [7:0] LEDs_8Bits_TRI_O;
  input GCLK;
  input [7:0] DIP_Switches_8Bits_TRI_I;
  input Digilent_AC97_Cntlr_BITCLK_pin;
  input Digilent_AC97_Cntlr_SDATA_IN_pin;
  output Digilent_AC97_Cntlr_SDATA_OUT_pin;
  output Digilent_AC97_Cntlr_SYNC_pin;
  output Digilent_AC97_Cntlr_RESET_N_pin;
  
  
  
  
  wire [31:0] DATA_line_ADC;
  wire en_line_ADC;
  wire ack_line_ADC;
  wire [31:0] DATA_line_fft_re;
  wire en_line_fft_re;
  wire ack_line_fft_re;
  wire [31:0] DATA_line_fft_im;
  wire en_line_fft_im;
  wire ack_line_fft_im;
  wire [31:0] DATA_line_ifft_re;
  wire en_line_ifft_re;
  wire ack_line_ifft_re;
  wire [31:0] DATA_line_ifft_im;
  wire en_line_ifft_im;
  wire ack_line_ifft_im;
  wire [31:0] DATA_line_DAC;
  wire en_line_DAC;
  wire ack_line_DAC;
  wire global_enable;
  wire global_reset;

  (* BOX_TYPE = "user_black_box" *)
  system
    system_i (
      .zio ( zio ),
      .rzq ( rzq ),
      .mcbx_dram_we_n ( mcbx_dram_we_n ),
      .mcbx_dram_udqs_n ( mcbx_dram_udqs_n ),
      .mcbx_dram_udqs ( mcbx_dram_udqs ),
      .mcbx_dram_udm ( mcbx_dram_udm ),
      .mcbx_dram_ras_n ( mcbx_dram_ras_n ),
      .mcbx_dram_odt ( mcbx_dram_odt ),
      .mcbx_dram_ldm ( mcbx_dram_ldm ),
      .mcbx_dram_dqs_n ( mcbx_dram_dqs_n ),
      .mcbx_dram_dqs ( mcbx_dram_dqs ),
      .mcbx_dram_dq ( mcbx_dram_dq ),
      .mcbx_dram_clk_n ( mcbx_dram_clk_n ),
      .mcbx_dram_clk ( mcbx_dram_clk ),
      .mcbx_dram_cke ( mcbx_dram_cke ),
      .mcbx_dram_cas_n ( mcbx_dram_cas_n ),
      .mcbx_dram_ba ( mcbx_dram_ba ),
      .mcbx_dram_addr ( mcbx_dram_addr ),
      .RS232_Uart_1_sout ( RS232_Uart_1_sout ),
      .RS232_Uart_1_sin ( RS232_Uart_1_sin ),
      .RESET ( RESET ),
      .Push_Buttons_5Bits_TRI_I ( Push_Buttons_5Bits_TRI_I ),
      .LEDs_8Bits_TRI_O ( LEDs_8Bits_TRI_O ),
      .GCLK ( GCLK ),
      .DIP_Switches_8Bits_TRI_I ( DIP_Switches_8Bits_TRI_I ),
      .Digilent_AC97_Cntlr_BITCLK_pin ( Digilent_AC97_Cntlr_BITCLK_pin ),
      .Digilent_AC97_Cntlr_SDATA_IN_pin ( Digilent_AC97_Cntlr_SDATA_IN_pin ),
      .Digilent_AC97_Cntlr_SDATA_OUT_pin ( Digilent_AC97_Cntlr_SDATA_OUT_pin ),
      .Digilent_AC97_Cntlr_SYNC_pin ( Digilent_AC97_Cntlr_SYNC_pin ),
      .Digilent_AC97_Cntlr_RESET_N_pin ( Digilent_AC97_Cntlr_RESET_N_pin ),
      .win_out_Wr_ACK_pin ( ack_line_ADC ),
      .win_out_bustoip_DATA_pin ( DATA_line_ADC ),
      .win_out_Wr_EN_pin ( en_line_ADC ),
		.fft_re_in_iptobus_DATA_pin ( DATA_line_fft_re ),
      .fft_re_in_Rd_ACK_pin ( ack_line_fft_re ),
      .fft_re_in_Rd_EN_pin ( en_line_fft_re ),
		.fft_im_in_iptobus_DATA_pin ( DATA_line_fft_im ),
      .fft_im_in_Rd_ACK_pin ( ack_line_fft_im ),
      .fft_im_in_Rd_EN_pin ( en_line_fft_im ),
      .ifft_re_out_Wr_ACK_pin ( ack_line_ifft_re ),
      .ifft_re_out_bustoip_DATA_pin ( DATA_line_ifft_re),
      .ifft_re_out_Wr_EN_pin ( en_line_ifft_re ),
      .ifft_im_out_Wr_ACK_pin ( ack_line_ifft_im ),
      .ifft_im_out_bustoip_DATA_pin ( DATA_line_ifft_im),
      .ifft_im_out_Wr_EN_pin ( en_line_ifft_im ),
      .HO_in_iptobus_DATA_pin ( DATA_line_DAC ),
      .HO_in_Rd_ACK_pin ( ack_line_DAC ),
      .HO_in_Rd_EN_pin ( en_line_DAC )

    );
	 
	global_en global_en(
		.all_clk_in(GCLK), 
		.all_res_in(RESET),
		.global_enable(global_enable),
		.global_reset(global_reset)
	);	 

	 fpga_hw fpga_hw (
		.GlobalReset(global_reset),
		.GlobalEnable1(global_enable),
		.clk(GCLK),
		.AC97_in( DATA_line_ADC ), 
		.AC97_in_en(en_line_ADC), 
		.AC97_in_ack(ack_line_ADC),
		.fft_re_out(DATA_line_fft_re),
		.fft_re_en(en_line_fft_re),
		.fft_re_ack(ack_line_fft_re),
		.fft_im_out(DATA_line_fft_im),
		.fft_im_en(en_line_fft_im),
		.fft_im_ack(ack_line_fft_im),
		.ifft_re_in(DATA_line_ifft_re),
		.ifft_re_en(en_line_ifft_re),
		.ifft_re_ack(ack_line_ifft_re),
		.ifft_im_in(DATA_line_ifft_im),
		.ifft_im_en(en_line_ifft_im),
		.ifft_im_ack(ack_line_ifft_im),
		.AC97_out(DATA_line_DAC),
		.AC97_out_en(en_line_DAC),
		.AC97_out_ack(ack_line_DAC)
	);

endmodule

module fpga_hw (
  input clk,
  input GlobalReset,
  input GlobalEnable1,
  input [31:0] AC97_in, // sfix32_En0
  input AC97_in_en, // ufix1
  output AC97_in_ack, // ufix1
  output [31:0] fft_re_out, // sfix32_En0
  input fft_re_en, // ufix1
  output fft_re_ack, // ufix1
  output [31:0] fft_im_out, // sfix32_En0
  input fft_im_en, // ufix1
  output fft_im_ack, // ufix1  
  input [31:0] ifft_re_in, // sfix32_En0
  input ifft_re_en, // ufix1
  output ifft_re_ack, // ufix1
  input [31:0] ifft_im_in, // sfix32_En0
  input ifft_im_en, // ufix1
  output ifft_im_ack, // ufix1
  input AC97_out_en, // ufix1
  output AC97_out_ack, // ufix1
  output [31:0] AC97_out// sfix32_En0

);

endmodule




module global_en
(
all_clk_in, 
all_res_in,
global_enable,
global_reset
);

input  all_clk_in;
input  all_res_in;


output global_enable;
output global_reset;
reg global_enable;
reg global_reset;

always @( posedge all_clk_in )begin
global_enable	<=1'b1;
global_reset	<=1'b0;
end

endmodule
